<script setup lang="ts">
import SearchInput from "./components/SearchInput.vue";
import UsersList from "./components/UsersList.vue";
import ListPagination from "./components/ListPagination.vue";
import { reactive } from "vue";
import { requestSearchUser } from "@/requests/users";
import { SEARCH_PER_PAGE } from "@/constants/search";

const usersState = reactive({ list: [] });
const searchState = reactive({
  currentPage: 1,
  loading: false,
  errorMessage: "",
  username: "",
  notFound: false,
  totalCount: 0,
});

async function requestSearch() {
  searchState.loading = true;
  searchState.notFound = false;

  const response = await requestSearchUser(
    searchState.username,
    searchState.currentPage,
    SEARCH_PER_PAGE
  );

  searchState.loading = false;
  if (response.error) {
    searchState.errorMessage = "Ops!! Um erro ocorreu...";
    return;
  }

  if (!response.items.length) {
    searchState.notFound = true;
    return;
  }

  usersState.list = [...usersState.list, ...response.items];
  searchState.totalCount = response.total_count;
}

function search(username: string) {
  usersState.list = [];
  searchState.username = username;
  searchState.currentPage = 1;
  searchState.errorMessage = "";
  requestSearch();
}

function searchPagination(page: number) {
  searchState.currentPage = page;
  requestSearch();
}
</script>

<template>
  <div class="container">
    <SearchInput @search="search" :loading="searchState.loading" />

    <div class="not-found" v-if="searchState.notFound">
      Nenhum usuário localizado com este nome...
    </div>

    <div v-if="Boolean(searchState.errorMessage)" class="error-message">
      {{ searchState.errorMessage }}
    </div>

    <UsersList :users="usersState.list" />

    <ListPagination
      v-if="Boolean(usersState.list?.length)"
      :currentPage="searchState.currentPage"
      :total="searchState.totalCount"
      @onClick="searchPagination"
      :loading="searchState.loading"
    />
  </div>
</template>

<style lang="scss" scoped>
.container {
  margin: 100px auto;
  max-width: 800px;

  .not-found {
    color: rgb(100, 100, 100);
    font-size: 18px;
    margin: 20px;
  }

  .error-message {
    background-color: #e35d6a;
    border-radius: 15px;
    color: #ffffff;
    margin-top: 20px;
    padding: 20px;
  }
}
</style>
